/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2004/12/15 17:44:20 $ $Revision: 1.18 $ */
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#ifndef _NoMesa
#include <GL/osmesa.h>
#include "XPM/icon.xpm"
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <ctype.h>
#include <math.h>
#include "anim.h"
#include "movie.h"
#include "global.h"
#ifndef _WIN32
#define _Fork
#include <unistd.h>
#include <X11/Xlib.h>
#else
#include <direct.h>
#define mkdir(dirname,perm) _mkdir(dirname)
#endif
#ifdef _WIN32
#include <process.h>
#endif
const double FRAMERATEARRAY[NFRV]={ 23.976, 24.0, 25.0, 29.97, 30.0,
  						50.0, 59.94, 60.0 };

/* Prototypes */
void FrameOff(GtkWidget *,gpointer);
void Menu_Frame(GtkWidget *,gpointer);
void perr(char *, ...);
int ilog(double);
gint Quit(GtkWidget *);
void Pause_Signal(GtkWidget *,gpointer);
void Write_PNG(char *, unsigned char *,int,int);
void Read_Objects(int,int);
void Redraw_Light(void);
void Plot_Objects(void);
void Write_rc(void);
void Write_Constraint(int);
void OutFile_Exists(ButtSignalfv *,int *);
void RedrawTex();
void Set_fpos(int i);

void Set_iValue(GtkWidget *widget,gpointer data)
{
  *(int *)data=atoi(gtk_entry_get_text(GTK_ENTRY(widget)));
}

void Create_Mpeg(char *s,char *tmp,int i)
{
  char *t;
  FILE *out;

  out=fopen(s,"w");
  fprintf(out,"# Mpeg_encode param file created by dat2mpg\n");
  fprintf(out,"PATTERN %s\n",movie.pattern);
  fprintf(out,"OUTPUT %s\n",movie.outfile);
  fprintf(out,"BASE_FILE_FORMAT PNM\n");
  fprintf(out,"INPUT_CONVERT pngtopnm *\n");
  fprintf(out,"GOP_SIZE %d\n",strlen(movie.pattern));
  fprintf(out,"SLICES_PER_FRAME 1\n");
  fprintf(out,"INPUT_DIR %s\n",tmp);
  fprintf(out,"INPUT\n");
  fprintf(out,"*.png [%0*d-%0*d]\n",
  	ilog(max(animation.marker1,animation.marker2)*animation.framerepeat),1,
	ilog(max(animation.marker1,animation.marker2)*animation.framerepeat),i);
  fprintf(out,"END_INPUT\n");
  fprintf(out,"PIXEL FULL\n");
  fprintf(out,"RANGE 10\n");
  fprintf(out,"PSEARCH_ALG LOGARITHMIC\n");
  fprintf(out,"BSEARCH_ALG CROSS2\n");
  fprintf(out,"IQSCALE %d\n",movie.quality*1);
  fprintf(out,"PQSCALE %d\n",movie.quality*2);
  fprintf(out,"BQSCALE %d\n",movie.quality*3);
  fprintf(out,"REFERENCE_FRAME DECODED\n");
  fprintf(out,"BUFFER_SIZE 327680\n");
  fprintf(out,"FRAME_RATE %lf\n",FRAMERATEARRAY[movie.framerate]);
  fprintf(out,"FORCE_ENCODE_LAST_FRAME\n");
  fprintf(out,"# End of File\n");
  fclose(out);
  t=(char *) calloc(strlen(s)+strlen("mpeg_encode")+15,sizeof(char));
  sprintf(t,"mpeg_encode -realquiet %s",s);
  system(t);
  free(t);
  remove(s);
}


void Set_Frame_Rate(GtkWidget *widget,gpointer data)
{
  movie.framerate=(int)data;
}

void Baj(int a,char *s)
{
  const char error[7][45]={ "Tmp directory does not exist. Create it!",
  			    "Output file exists",
  			    "Cannot open output file",
  			    "Invalid caracter in pattern string",
  			    "Size must be positive",
  			    "Tmp directory is not writable.",
  			    "Width must be multiple of 4" };
  if (a==-1) {
    gtk_label_set_label(GTK_LABEL(movie.entry[NENTR-1]),s);
  } else {
    gtk_label_set_label(GTK_LABEL(movie.entry[NENTR-1]),error[a]);
  }
}

int Set_Movie_Params(void)
{
/*  char *error,errs[256];*/

  /* Clear Error */
  gtk_label_set_label(GTK_LABEL(movie.entry[NENTR-1]),"");
  { /* 0: tmpdir */
    struct stat tmpdirinfo;
    free(movie.tmpdir);
    movie.tmpdir=strdup(gtk_entry_get_text(GTK_ENTRY(movie.entry[0])));
    if ((stat(movie.tmpdir,&tmpdirinfo)!=0) || 
	(!S_ISDIR(tmpdirinfo.st_mode))) {
      /* directory does not exist, we do not create it */
      Baj(0,"");
      return(1);
    }
  }
  { /* 1: outfile */
    FILE *out;
    if (movie.outfile!=NULL) free(movie.outfile);
    movie.outfile=strdup(gtk_entry_get_text(GTK_ENTRY(movie.entry[1])));
    out=fopen(movie.outfile,"r");
    if (out!=NULL) {
      Baj(1,"");
      fclose(out);
      return(1);
    }
    out=fopen(movie.outfile,"w");
    if (out==NULL) {
      Baj(2,"");
      return(1);
    }
    fclose(out);
    remove(movie.outfile);
  }
  { /* 2: pattern */
    int a;
    if (movie.pattern!=NULL) free(movie.pattern);
    movie.pattern=strdup(gtk_entry_get_text(GTK_ENTRY(movie.entry[2])));
    for (a=0;a<(int)strlen(movie.pattern);a++) {
      if ((toupper(movie.pattern[a])!='I') &&
	  (toupper(movie.pattern[a])!='B') &&
	  (toupper(movie.pattern[a])!='P')) {
	Baj(3,"");
	return(1);
      }
    }
  }
  /* 3: frame rate nothing to be done */
  { /* 4: frame repeat */
    animation.framerepeat=max(1,atoi(
	  	gtk_entry_get_text(GTK_ENTRY(movie.entry[4]))));
  }
  { /* 5: quad resolution */
    movie.quadres=max(2,atoi(
	  	gtk_entry_get_text(GTK_ENTRY(movie.entry[5]))));
  }
  { /* 6: quality */
    movie.quality=max(2,atoi(
	  	gtk_entry_get_text(GTK_ENTRY(movie.entry[6]))));
  }
  { /* width, height */
    movie.width=atof(gtk_entry_get_text(GTK_ENTRY(movie.entry[7])));
    movie.height=atof(gtk_entry_get_text(GTK_ENTRY(movie.entry[8])));
    if ((movie.width<=0) || (movie.height<=0)) {
      Baj(4,"");
      return(1);
    }
    if (movie.width%4) {
      Baj(6,"");
      return(1);
    }
  }
  return(0);
}

void Plot_Frame(int a,char *name,char *buff,int fpos)
{
  glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
  glLoadIdentity();
  Read_Objects(a,0);
  Set_fpos(fpos);
  glLoadIdentity();
  Redraw_Light();
  glLoadIdentity();
  Plot_Objects();
  glFlush();
  Write_PNG(name,buff,movie.width,movie.height);
}

void CloseMovieParam(GtkWidget *widget,gpointer data)
{
#ifndef _NoMesa
  int a,b,l,i,d;
  int quadres;
  char *png_name,*png_templ,*dir_tmp,*mpeg_par;
  GLUquadricObj *q;
  OSMesaContext os_context=NULL;
  void *buff=NULL;
  struct timeb t;
#ifdef _Fork
  pid_t skip;
#endif

  d=(int)data;
  if (d) {	/* ok was pressed */
    /* Check if data is ok */
    if ((d==1) && (Set_Movie_Params())) return;
    l=ilog(max(animation.marker1,animation.marker2)*animation.framerepeat)
    					+strlen(movie.tmpdir)+10;
    png_templ=(char *)malloc(sizeof(char)*l);
    png_name=(char *)malloc(sizeof(char)*l);
    dir_tmp=(char *)malloc(sizeof(char)*l);
    mpeg_par=(char *)malloc(sizeof(char)*(l+20));
    ftime(&t);
    i=(t.time&8191)*1000+t.millitm;
    for (a=0,b=0;a<10 && b<1;a++) {
      sprintf(dir_tmp,"%s/mozi%d",movie.tmpdir,i);
      if (mkdir(dir_tmp,0755)==0) b=1;
    }
    if (b<1) {
      free(png_templ);
      free(png_name);
      free(dir_tmp);
      free(mpeg_par);
      Baj(5,"");
      return;
    }
#ifdef _Fork
    skip=fork();
    if (!skip) {
#else
      /* Close window */
      gtk_signal_disconnect_by_func(GTK_OBJECT(ctrlwin),
				  GTK_SIGNAL_FUNC (Quit), NULL);
      gtk_signal_disconnect_by_func(GTK_OBJECT(glwin),
				  GTK_SIGNAL_FUNC (Quit), NULL);
      gtk_widget_destroy(ctrlwin);
      gtk_widget_destroy(glwin);
      gtk_widget_destroy(movie.parammoviewindow);
#endif
      movie.paramwindowisup=2;
      /* Save current context it seems that it is not needed... */
      quadres=gl.quad.st;
      gl.quad.st=movie.quadres;
      gl.quad.sl=gl.quad.st*2;
      q=gl.quad.q;
      /* Create off screen context */
      os_context = OSMesaCreateContext( OSMESA_RGB, NULL );
      if (os_context == NULL) perr("unable to create os context\n");
      buff = (void*) malloc( 3 * movie.width * movie.height );
      if (buff==NULL) perr("os buffer allocation error\n");
      if (! OSMesaMakeCurrent( os_context, buff, GL_UNSIGNED_BYTE,
		  movie.width, movie.height)) perr("os buffer bind error\n");
      /* GL Drawing */
      /* Initial settings */
      glLoadIdentity();
      glGenTextures(gl.texture.num, gl.texture.texture);
      for (a=0;a<gl.texture.num;a++) {
	glBindTexture(GL_TEXTURE_2D, gl.texture.texture[a]);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, gl.texture.detail[a].width,
	  gl.texture.detail[a].height, 0,
	  GL_RGB, GL_UNSIGNED_BYTE, gl.texture.detail[a].data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
      }
      glClearColor(gl.bg[0],gl.bg[1],gl.bg[2],gl.bg[3]);
      glClearDepth(1.0);
      glClearStencil(0);
      glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
      glDepthFunc(GL_LESS);
      glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
      glEnable(GL_DEPTH_TEST);
      glShadeModel(GL_SMOOTH);
      glViewport(0,0,movie.width,movie.height);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluPerspective(gl.persp.angle,(double)movie.width/movie.height,
	  gl.persp.zNear,gl.persp.zFar);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      glEnable(GL_LIGHT0);
      glDisable(GL_LIGHT0);
      for (a=0;a<gl.lightmodel.model;a++) {
	glLightModelfv(gl.lightmodel.modelname[a],
		    gl.lightmodel.modelparam[a]);
      }
      for (a=0;a<MaxLight;a++) {
	if (gl.light[a].on) {
	  for (b=0;b<MaxLightParam;b++) {
	    glLightfv(gl.light[a].light, gl.light[a].type[b],
		gl.light[a].param[b]);
	  }
	  glEnable(gl.light[a].light);
	} else {
	  glDisable(gl.light[a].light);
	}
      }
      glEnable(GL_LIGHTING);
      glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
      glEnable(GL_LIGHT0);
      gl.quad.q = gluNewQuadric();
      gluQuadricNormals(gl.quad.q, GL_SMOOTH);
      gluQuadricTexture(gl.quad.q, GL_TRUE);
      glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
      glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
      Redraw_Light();

      movie.RPN_vars[1]=gl.x;
      movie.RPN_vars[2]=gl.y;
      movie.RPN_vars[3]=gl.z;
      movie.RPN_vars[4]=gl.phix;
      movie.RPN_vars[5]=gl.phiy;
      movie.RPN_vars[6]=gl.phiz;
      sprintf(mpeg_par,"%s/mpeg_encode.par",dir_tmp);
      sprintf(png_templ,"%s/%%0%dd.png",dir_tmp,
	ilog(max(animation.marker1,animation.marker2)*animation.framerepeat));
      i=0;
      /* plot!!! */
      if (animation.playdir<2) {
	for (a=animation.marker1;a<animation.marker2;a+=anim.frameskip) {
	  for (b=0;b<animation.framerepeat;b++) {
	    sprintf(png_name,png_templ,i);i++;
	    Plot_Frame(a,png_name,buff,i);
	  }
	}
      } else {
	for (a=animation.marker2;a>=animation.marker1;a-=anim.frameskip) {
	  for (b=0;b<animation.framerepeat;b++) {
	    sprintf(png_name,png_templ,i);i++;
	    movie.RPN_vars[0]=(double)i;
	    Plot_Frame(a,png_name,buff,i);
	  }
	}
      }
      Create_Mpeg(mpeg_par,dir_tmp,i-1);

      /* clean up */
      remove(mpeg_par);
      for (a=0;a<=i;a++) {
	sprintf(png_name,png_templ,a);
	remove(png_name);
      }
      rmdir(dir_tmp);
      free(png_templ);
      free(png_name);
      free(dir_tmp);
      free(mpeg_par);
      /* Quit */
      if (anim.writerc) Write_rc();
      else Write_Constraint(0);
      gtk_main_quit();
      exit(0);
#ifdef _Fork
    } else {
      gtk_widget_hide(movie.parammoviewindow);
      movie.paramwindowisup=2;
    }
#endif
  } else {
    gtk_widget_hide(movie.parammoviewindow);
    movie.paramwindowisup=2;
  }
#endif		/* _NoMesa */
}

/* Entry: 12,13 width, height NENTR-1 error */
void CreateParamWin(void)
{
#ifdef _NoMesa
  GtkWidget *dialog,*label,*ok;

  dialog=gtk_dialog_new();
  label=gtk_label_new(
      "This feature requires OSMesa and is not avilable in this code...");
  ok=gtk_button_new_with_label("Ok");
  gtk_signal_connect_object (GTK_OBJECT (ok), "clicked",
		    GTK_SIGNAL_FUNC(gtk_widget_destroy), dialog);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area),ok);
  gtk_container_add (GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
  gtk_widget_show_all(dialog);
  return;
#else

  GtkWidget *window;		/* main parameter window */
  GtkStyle  *style;		/* style for pixmap background */
  GdkPixmap *pixmap;		/* pixmap for pixmap buttons */
  GdkBitmap *mask;		/* pixmap mask */
  GtkWidget *vbox;		/* main vbox */
  GtkWidget *hbox[NHBOX];	/* hbox for each parameter */
  GtkWidget *label;		/* Santa Claus, oh no... label */
  GtkWidget *frameratemenu;	/* Frame rate possibilities */
  GtkWidget *mitem;		/* menu item of the previous */
  GtkWidget *ok;		/* ok, let's do it */
  GtkWidget *cancel;		/* I changed my mind */
  char s[SL];			/* we need a string */
  int a,e,i,k,again;
  double r;
  FILE *in;

  if (movie.paramwindowisup==1) return;
  if (movie.paramwindowisup==2) {
    movie.paramwindowisup=1;
    /* set filename */
    i=0;again=1;
    do {
      if (i==0) sprintf(s,"movie.mpg");
      else sprintf(s,"movie%d.mpg",i);
      i++;
      in=fopen(s,"r");
      if (in!=NULL) fclose(in);
      else again=0;
    } while ((again) && (i<100000));
    if (again) sprintf(s,"movie.mpg");
    gtk_entry_set_text(GTK_ENTRY(movie.entry[1]),s);
    gtk_widget_show(movie.parammoviewindow);
    sprintf(s,"%d",min(99999999,gl.width));
    gtk_entry_set_text(GTK_ENTRY(movie.entry[7]),s);
    sprintf(s,"%d",min(99999999,gl.height));
    gtk_entry_set_text(GTK_ENTRY(movie.entry[8]),s);
    return;
  }
  movie.paramwindowisup=1;
  movie.parammoviewindow=window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW (window), "Mpeg_encode parameters");
  gtk_widget_realize(window);
  style= gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
		     &style->bg[GTK_STATE_NORMAL],XPMicon);
  gdk_window_set_icon(window->window,NULL,pixmap,mask);
  vbox=gtk_vbox_new(TRUE,0);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);
  for (a=0;a<NHBOX;a++) {
    hbox[a]=gtk_hbox_new(FALSE,0);
    gtk_box_pack_start (GTK_BOX (vbox), hbox[a], TRUE, TRUE, 3);
    gtk_widget_show(hbox[a]);
  }

  e=0;
  a=0; /* 0: tmp dir */
  label=gtk_label_new("Tmp directory:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),movie.tmpdir);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=1; /* 1: output file */
  label=gtk_label_new("Output file:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new();
  i=0;again=1;
  do {
    if (i==0) sprintf(s,"movie.mpg");
    else sprintf(s,"movie%d.mpg",i);
    i++;
    in=fopen(s,"r");
    if (in!=NULL) fclose(in);
    else again=0;
  } while ((again) && (i<100000));
  if (again) sprintf(s,"movie.mpg");
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=2; /* 2: pattern string */
  label=gtk_label_new("Pattern string (IPB):");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),"IBBPBBPBBPBBPBBP");
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=3; /* 3: pattern string */
  label=gtk_label_new("Frame rate");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_option_menu_new();
  frameratemenu=gtk_menu_new();
  for (i=0;i<NFRV;i++) {
    r=1.0;k=0;
    while (fmod(FRAMERATEARRAY[i]*r,1.0)>0.00001) {
      k++;r*=10.0;
    }
    sprintf(s,"%.*lf",k,FRAMERATEARRAY[i]);
    mitem=gtk_menu_item_new_with_label(s);
    gtk_signal_connect(GTK_OBJECT(mitem),"activate",
	GTK_SIGNAL_FUNC(Set_Frame_Rate),(gpointer) i);
    gtk_widget_show(mitem);
    gtk_menu_append (GTK_MENU (frameratemenu), mitem);
  }
  gtk_menu_set_active(GTK_MENU(frameratemenu),2);
  movie.framerate=2;
  gtk_option_menu_set_menu (GTK_OPTION_MENU (movie.entry[e]), frameratemenu);
  gtk_widget_show(frameratemenu);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=4; /* 4: Frame repeat */
  label=gtk_label_new("Repeat frames n times:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new();
  gtk_widget_set_usize(movie.entry[e],50,0);
  sprintf(s,"%d",min(999999,animation.framerepeat));
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=5; /* 5: quad resolution */
  label=gtk_label_new("Quad resolution:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new();
  gtk_widget_set_usize(movie.entry[e],50,0);
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),"32");
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=6; /* 6: Movie quality */
  label=gtk_label_new("Movie quality (1 highest):");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new();
  gtk_widget_set_usize(movie.entry[e],50,0);
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),"5");
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=7; /* 7 size */
  label=gtk_label_new("Screen width (=n*4!):");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new_with_max_length(8);
  gtk_widget_set_usize(movie.entry[e],40,0);
  sprintf(s,"%d",min(99999999,gl.width));
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;
  label=gtk_label_new("Height:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.entry[e]=gtk_entry_new_with_max_length(8);
  gtk_widget_set_usize(movie.entry[e],40,0);
  sprintf(s,"%d",min(99999999,gl.height));
  gtk_entry_set_text(GTK_ENTRY(movie.entry[e]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[e], FALSE, FALSE, 3);
  gtk_widget_show(movie.entry[e]);e++;

  a=8; /* 8: ok/cancel */
  ok=gtk_button_new_with_label("Ok");
  cancel=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start (GTK_BOX (hbox[a]), ok, TRUE, TRUE, 3);
  gtk_box_pack_start (GTK_BOX (hbox[a]), cancel, TRUE, TRUE, 3);
  gtk_widget_show(ok);
  gtk_widget_show(cancel);

  a=9; /* 9: error message */
  movie.entry[NENTR-1]=gtk_label_new("");
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.entry[NENTR-1], TRUE, TRUE, 3);
  gtk_widget_show(movie.entry[NENTR-1]);

  gtk_widget_show(window);

  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
	    GTK_SIGNAL_FUNC (CloseMovieParam), (gpointer)0 );
  gtk_signal_connect (GTK_OBJECT (cancel), "clicked",
	    GTK_SIGNAL_FUNC (CloseMovieParam), (gpointer)0 );
  gtk_signal_connect (GTK_OBJECT (ok), "clicked",
	    GTK_SIGNAL_FUNC (CloseMovieParam), (gpointer)1 );
#endif
}

void Reshape_Anim(void)
{
  int w,sliderw,avw,m2,s1,s2;

  w=animation.playposslider->allocation.width;
  sliderw=animation.playposslider->requisition.width;
  avw=w-sliderw-16;
  if (animation.marker2<0) m2=animation.maxframe-animation.marker2+1;
  else m2=animation.marker2;
  m2-=animation.marker1;
  s1=avw*animation.marker1/max(animation.maxframe,1);
  s2=avw*m2/max(animation.maxframe,1);
  gtk_widget_set_usize(animation.space1,s1,0);
  gtk_widget_set_usize(animation.space2,s2,0);
}

void ChangeMarker(GtkWidget *widget,gpointer data)
{
  int a,savedval,val,m2;
  char s[8];

  a=(int) data;
  savedval=val=atoi(gtk_entry_get_text(GTK_ENTRY(widget)));
  if (a) {	/* End */
    if (val<0) val=animation.maxframe+val+1;
    val=max(animation.marker1,val);
    animation.marker2=min(val,animation.maxframe);
    if (savedval!=val) {
      sprintf(s,"%d",min(999999,animation.marker2));
      gtk_entry_set_text(GTK_ENTRY(widget), s);
    }
  } else {	/* Beginning */
    if (animation.marker2<0) m2=animation.maxframe-animation.marker2+1;
    else m2=animation.marker2;
    val=min(m2,val);
    animation.marker1=max(val,0);
    if (savedval!=val) {
      sprintf(s,"%d",min(999999,animation.marker1));
      gtk_entry_set_text(GTK_ENTRY(widget), s);
    }
  }
  Reshape_Anim();
}


void Create_Movie_Frame(GtkWidget *frame)
{
  GtkWidget *vbox;		/* vbox for a little space */
  GtkWidget *hbox;		/* hbox for eye position */
  GtkWidget *dummy;		/* dummy widget for labels */
  GtkWidget *m1,*m2;		/* widgets for markers  */
  GtkWidget *fr;		/* widget for frame repeat text  */
  GtkWidget *mozi;		/* button for creating movie */
  GtkWidget *off;		/* switch frame off button */
  char s[8];			/* string for frameskip */
  int m2val;			/* converted value of marker2 */

  vbox = gtk_vbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  hbox = gtk_hbox_new(FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,3);
  dummy=gtk_label_new("Start:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  animation.markerbox1=m1=gtk_entry_new_with_max_length(6);
  gtk_widget_set_usize(m1,40,0);
  sprintf(s,"%d",min(999999,animation.marker1));
  gtk_entry_set_text(GTK_ENTRY(m1), s);
  gtk_box_pack_start(GTK_BOX(hbox), m1, FALSE, FALSE, 3);
  gtk_widget_show(m1);
  dummy=gtk_label_new("End:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  animation.markerbox2=m2=gtk_entry_new_with_max_length(6);
  gtk_widget_set_usize(m2,40,0);
  if (animation.marker2<0) m2val=animation.maxframe-animation.marker2+1;
  else m2val=animation.marker2;
  sprintf(s,"%d",min(999999,m2val));
  gtk_entry_set_text(GTK_ENTRY(m2), s);
  gtk_box_pack_start(GTK_BOX(hbox), m2, FALSE, FALSE, 3);
  gtk_widget_show(m2);
  dummy=gtk_label_new("FR:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  fr=gtk_entry_new_with_max_length(6);
  gtk_widget_set_usize(fr,22,0);
  sprintf(s,"%d",min(999999,animation.framerepeat));
  gtk_entry_set_text(GTK_ENTRY(fr), s);
  gtk_box_pack_start(GTK_BOX(hbox), fr, FALSE, FALSE, 3);
  gtk_widget_show(fr);
  mozi=gtk_button_new_with_label("Create movie");
  gtk_box_pack_start(GTK_BOX(hbox),mozi,FALSE,FALSE,3);
  gtk_widget_show(mozi);
  off=gtk_check_button_new_with_label("Off");
  gtk_box_pack_end(GTK_BOX(hbox),off,FALSE,FALSE,0);
  gtk_widget_show(off);
  gtk_widget_show(hbox);
  gtk_widget_show(vbox);
  /* Signals */

  gtk_signal_connect (GTK_OBJECT (mozi), "clicked",
	    GTK_SIGNAL_FUNC (CreateParamWin), NULL );
  gtk_signal_connect (GTK_OBJECT (m1), "activate",
	    GTK_SIGNAL_FUNC (ChangeMarker), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (m2), "activate",
	    GTK_SIGNAL_FUNC (ChangeMarker), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT (fr), "activate",
	    GTK_SIGNAL_FUNC (Set_iValue),
	    (gpointer)&animation.framerepeat);
  gtk_signal_connect (GTK_OBJECT (off), "toggled",
	    GTK_SIGNAL_FUNC (FrameOff), (gpointer)frame);
}

void Marker_Move(GtkWidget *widget,GdkEvent *event)
{
  int s1,s2,x,l,ns1,ns2;
  char s[8];

  s1=animation.space1->allocation.width;
  s2=animation.space2->allocation.width;
  l=animation.playposslider->allocation.width-
		animation.playposslider->requisition.width;
  if (event->type==GDK_BUTTON_PRESS) {
    x=animation.markermousex=event->button.x;
    if (x>l) {
      /* pop up controls */
      Menu_Frame(widget,(gpointer) 1);
      return;
    }
    animation.markertomove=0;
    if (abs(s1-x)>abs(s1+s2-x)) {
      animation.markertomove++;
    }
  } else {
    x=animation.markermousex=event->motion.x;
    if (x>l) {
      return;
    }
  }
  x=min(x,l);
  x=max(x,1);
  ns1=s1;ns2=s2;
  if (animation.markertomove) {	/* marker2 */
    ns2=max(1,x-s1);
    ns1=min(x,s1);
  } else {	/* marker1 */
    ns1=x;
    ns2=max(1,s2+s1-x);
  }
  gtk_widget_set_usize(animation.space1,ns1,0);
  gtk_widget_set_usize(animation.space2,ns2,0);
  animation.marker1=ns1*animation.maxframe/l;
  animation.marker2=(ns1+ns2)*animation.maxframe/l;
  sprintf(s,"%d",min(999999,animation.marker1));
  gtk_entry_set_text(GTK_ENTRY(animation.markerbox1), s);
  sprintf(s,"%d",min(999999,animation.marker2));
  gtk_entry_set_text(GTK_ENTRY(animation.markerbox2), s);
  if ((GTK_ADJUSTMENT(animation.playposslideradj)->value<animation.marker1) ||
      (GTK_ADJUSTMENT(animation.playposslideradj)->value>animation.marker2)) {
    if (!anim.running) Pause_Signal(gl.glarea,NULL);
  }
}

void CreateSnap()
{
#ifndef _NoMesa
  int width,height,quadres,a,b;
  OSMesaContext os_context=NULL;
  void *buff=NULL;
  GLUquadricObj *q;
  char *png_name;

  width=atoi(gtk_entry_get_text(GTK_ENTRY(movie.createentr[2])));
  height=atoi(gtk_entry_get_text(GTK_ENTRY(movie.createentr[3])));
  quadres=gl.quad.st;
  q=gl.quad.q;
  gl.quad.st=atoi(gtk_entry_get_text(GTK_ENTRY(movie.createentr[1])));
  gl.quad.sl=gl.quad.st*2;
  os_context = OSMesaCreateContext( OSMESA_RGB, NULL );
  if (os_context == NULL) perr("unable to create os context\n");
  buff = (void*) malloc( 3 * width * height );
  if (buff==NULL) perr("os buffer allocation error\n");
  if (! OSMesaMakeCurrent( os_context, buff, GL_UNSIGNED_BYTE,
	      width, height)) perr("os buffer bind error\n");
  gtk_widget_show(movie.pleasewait);
  gtk_main_iteration();
  gtk_main_iteration();
  /* GL Drawing */
  /* Initial settings */
  glLoadIdentity();
  glGenTextures(gl.texture.num, gl.texture.texture);
  for (a=0;a<gl.texture.num;a++) {
    glBindTexture(GL_TEXTURE_2D, gl.texture.texture[a]);
    glTexImage2D(GL_TEXTURE_2D, 0, 3, gl.texture.detail[a].width,
      gl.texture.detail[a].height, 0,
      GL_RGB, GL_UNSIGNED_BYTE, gl.texture.detail[a].data);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  }
  glClearColor(gl.bg[0],gl.bg[1],gl.bg[2],gl.bg[3]);
  glClearDepth(1.0);
  glClearStencil(0);
  glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
  glDepthFunc(GL_LESS);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
  glEnable(GL_DEPTH_TEST);
  glShadeModel(GL_SMOOTH);
  glViewport(0,0,width,height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(gl.persp.angle,(double)width/height,
      gl.persp.zNear,gl.persp.zFar);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glEnable(GL_LIGHT0);
  glDisable(GL_LIGHT0);
  for (a=0;a<gl.lightmodel.model;a++) {
    glLightModelfv(gl.lightmodel.modelname[a],
		gl.lightmodel.modelparam[a]);
  }
  for (a=0;a<MaxLight;a++) {
    if (gl.light[a].on) {
      for (b=0;b<MaxLightParam;b++) {
	glLightfv(gl.light[a].light, gl.light[a].type[b],
	    gl.light[a].param[b]);
      }
      glEnable(gl.light[a].light);
    } else {
      glDisable(gl.light[a].light);
    }
  }
  glEnable(GL_LIGHTING);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_LIGHT0);
  gl.quad.q = gluNewQuadric();
  gluQuadricNormals(gl.quad.q, GL_SMOOTH);
  gluQuadricTexture(gl.quad.q, GL_TRUE);
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
  Redraw_Light();
  glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
  glLoadIdentity();
  Read_Objects(animation.framepc,0);
  glLoadIdentity();
  Redraw_Light();
  glLoadIdentity();
  Plot_Objects();
  glFlush();
  png_name=strdup(gtk_entry_get_text(GTK_ENTRY(movie.createentr[0])));
  Write_PNG(png_name,buff,width,height);
  OSMesaDestroyContext(os_context);
  free(png_name);
  free(buff);

  gl.quad.st=quadres;
  gl.quad.sl=gl.quad.st*2;
  gl.quad.q=q;
  gtk_widget_hide(movie.createsnapwin);
  movie.createsnapisup=2;
#endif
}

void CreateSnapOk(GtkWidget *widget,gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
  movie.createsnapisup=0;
  CreateSnap();
}

void CloseCreateSnap(GtkWidget *widget,gpointer data)
{
  int d;
  char s[SL];			/* we need a string */
#ifndef _NoMesa
  FILE *in;
#endif

  d=(int)data;
  if (d==2) {
    /* refresh do not close actually ;-) */
    sprintf(s,"%d",min(99999999,gl.width));
    gtk_entry_set_text(GTK_ENTRY(movie.createentr[2]),s);
    sprintf(s,"%d",min(99999999,gl.height));
    gtk_entry_set_text(GTK_ENTRY(movie.createentr[3]),s);
  } else if (d==1) {
    /* ok was pressed */
#ifndef _NoMesa
    in=fopen(gtk_entry_get_text(GTK_ENTRY(movie.createentr[0])),"r");
    if (in!=NULL) {
      fclose(in);
      OutFile_Exists(CreateSnapOk,&movie.createsnapisup);
      return;
    }
    CreateSnap();
#endif
  } else {
    /* d==0 cancel */
    gtk_widget_hide(movie.createsnapwin);
    movie.createsnapisup=2;
  }
}

void MesaSnap(void)
{
#ifdef _NoMesa
  GtkWidget *dialog,*label,*ok;

  dialog=gtk_dialog_new();
  label=gtk_label_new(
      "This feature requires OSMesa and is not avilable in this code...");
  ok=gtk_button_new_with_label("Ok");
  gtk_signal_connect_object (GTK_OBJECT (ok), "clicked",
		    GTK_SIGNAL_FUNC(gtk_widget_destroy), dialog);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area),ok);
  gtk_container_add (GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
  gtk_widget_show_all(dialog);
  return;
#else
  GtkWidget *window;		/* main parameter window */
  GtkStyle  *style;		/* style for pixmap background */
  GdkPixmap *pixmap;		/* pixmap for pixmap buttons */
  GdkBitmap *mask;		/* pixmap mask */
  GtkWidget *vbox;		/* main vbox */
  GtkWidget *hbox[NCE+3];	/* hbox for each parameter */
  GtkWidget *label;		/* Santa Claus, oh no... label */
  GtkWidget *refresh;		/* Get window's params */
  GtkWidget *ok;		/* ok, let's do it */
  GtkWidget *cancel;		/* I changed my mind */
  char s[SL];			/* we need a string */
  int a,i,again;
  FILE *in;

  if (movie.createsnapisup==1) return;
  if (movie.createsnapisup==2) {
    movie.createsnapisup=1;
    i=0;again=1;
    do {
      if (i==0) sprintf(s,"movie.png");
      else sprintf(s,"movie%d.png",i);
      i++;
      in=fopen(s,"r");
      if (in!=NULL) fclose(in);
      else again=0;
    } while ((again) && (i<100000));
    if (again) sprintf(s,"movie.png");
    gtk_entry_set_text(GTK_ENTRY(movie.createentr[0]),s);
  }
  movie.createsnapisup=1;
  movie.createsnapwin=window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW (window), "Create Snapshot parameters");
  gtk_widget_realize(window);
  style= gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
		     &style->bg[GTK_STATE_NORMAL],XPMicon);
  gdk_window_set_icon(window->window,NULL,pixmap,mask);
  vbox=gtk_vbox_new(TRUE,0);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);
  for (a=0;a<NCE+3;a++) {
    hbox[a]=gtk_hbox_new(FALSE,0);
    gtk_box_pack_start (GTK_BOX (vbox), hbox[a], TRUE, TRUE, 3);
    gtk_widget_show(hbox[a]);
  }

  a=0; /* output filename */
  label=gtk_label_new("Output file:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.createentr[a]=gtk_entry_new();
  i=0;again=1;
  do {
    if (i==0) sprintf(s,"movie.png");
    else sprintf(s,"movie%d.png",i);
    i++;
    in=fopen(s,"r");
    if (in!=NULL) fclose(in);
    else again=0;
  } while ((again) && (i<100000));
  if (again) sprintf(s,"movie.png");
  gtk_entry_set_text(GTK_ENTRY(movie.createentr[a]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.createentr[a], FALSE, FALSE, 3);
  gtk_widget_show(movie.createentr[a]);

  a=1; /* 1: quad resolution */
  label=gtk_label_new("Quad resolution:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.createentr[a]=gtk_entry_new();
  gtk_widget_set_usize(movie.createentr[a],50,0);
  gtk_entry_set_text(GTK_ENTRY(movie.createentr[a]),"128");
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.createentr[a], FALSE, FALSE, 3);
  gtk_widget_show(movie.createentr[a]);

  a=2; /* 2: width */
  label=gtk_label_new("Picture width:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.createentr[a]=gtk_entry_new();
  gtk_widget_set_usize(movie.createentr[a],50,0);
  sprintf(s,"%d",min(99999999,gl.width));
  gtk_entry_set_text(GTK_ENTRY(movie.createentr[a]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.createentr[a], FALSE, FALSE, 3);
  gtk_widget_show(movie.createentr[a]);

  a=3; /* 3: height */
  label=gtk_label_new("Picture height:");
  gtk_box_pack_start (GTK_BOX (hbox[a]), label, FALSE, FALSE, 3);
  gtk_widget_show(label);
  movie.createentr[a]=gtk_entry_new();
  gtk_widget_set_usize(movie.createentr[a],50,0);
  sprintf(s,"%d",min(99999999,gl.height));
  gtk_entry_set_text(GTK_ENTRY(movie.createentr[a]),s);
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.createentr[a], FALSE, FALSE, 3);
  gtk_widget_show(movie.createentr[a]);

  a=4; /* get window's size */
  refresh=gtk_button_new_with_label("Set size of GL window");
  gtk_box_pack_start (GTK_BOX (hbox[a]), refresh, TRUE, TRUE, 3);
  gtk_widget_show(refresh);

  a=5; /* 5: ok/cancel */
  ok=gtk_button_new_with_label("Ok");
  cancel=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start (GTK_BOX (hbox[a]), ok, TRUE, TRUE, 3);
  gtk_box_pack_start (GTK_BOX (hbox[a]), cancel, TRUE, TRUE, 3);
  gtk_widget_show(ok);
  gtk_widget_show(cancel);

  a=6; /* 6: Please wait */
  movie.pleasewait=gtk_label_new("Please, wait...");
  gtk_box_pack_start (GTK_BOX (hbox[a]), movie.pleasewait, TRUE, TRUE, 3);

  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
	    GTK_SIGNAL_FUNC (CloseCreateSnap), (gpointer)0 );
  gtk_signal_connect (GTK_OBJECT (refresh), "clicked",
	    GTK_SIGNAL_FUNC (CloseCreateSnap), (gpointer)2 );
  gtk_signal_connect (GTK_OBJECT (cancel), "clicked",
	    GTK_SIGNAL_FUNC (CloseCreateSnap), (gpointer)0 );
  gtk_signal_connect (GTK_OBJECT (ok), "clicked",
	    GTK_SIGNAL_FUNC (CloseCreateSnap), (gpointer)1 );

  gtk_widget_show(window);
#endif
}

void reset_movie(void)
{
  movie.paramwindowisup=0;
  movie.createsnapisup=0;
  movie.tmpdir=strdup("/tmp");
  movie.outfile=NULL;
  movie.pattern=NULL;
  movie.dx=NULL;
  movie.dy=NULL;
  movie.dz=NULL;
  movie.rx=NULL;
  movie.ry=NULL;
  movie.rz=NULL;
}

/* EOF */
